  // スプライトシートをアニメさせる ----------------------------------------------
  smart.Animation = smart.extend(smart.Canvas,{
    // w h 追加 -- 120531 
    init:function(w_ , h_ ,img_ ,fps_ ) {
      smart.Canvas.apply(this, [w_, h_ ]);
      this.name = "Animation";
      this.id = SMART + "-animation" + smart.guid++;
      this._source = null;
      this._cols = 1;
      this._total = 1;

      var instance = this;
      this._timeline = new smart.Timeline(fps_);
      this._timeline.enterframe(function(e) {
        if(instance._source) {
          instance._render(e.target.frame-1);
        }
        instance.trigger(e.type,e); // -- 120818
      });
      this._timeline.lastframe(function(e) {
        instance.trigger(e.type,e); // -- 120818
      });
      if(img_) { this.source = img_; }
    },
    fps:{
      set:function(n){
        var active = this._timeline.active;
        this._timeline.stop();
        this._timeline.fps = n;
        if(active) { this._timeline.play(); }
      },
      get:function() {return this._timeline.fps}
    },
    source:{
      set:function(img_) {
        this._source = img_;
        this._index = 0;
        this._cols = Math.floor(this._source.width  / this._width);
        this._timeline.total = this._cols * Math.floor(this._source.height / this._height);
        this._render(this.frame = 0);
      }
    },
    _render:function(index) {
      index = index % this._timeline.total;
      var u = (index % this._cols ) * this._width;
      var v = Math.floor(index / this._cols) * this._height;
      this.clear();
      this._ctx.drawImage(this._source, u, v, this._width ,this._height ,0 ,0 ,this._width ,this._height);
    },
    play:function(fr_) {
      this._timeline.play(fr_);
    },
    frame:{
      get:function()  {return this._timeline.frame},
      set:function(n) {this._timeline.frame = n}
    },
    total:{
      get:function()  {return this._timeline.total} // -- 120816
    },
    stop:function(fr_) {
      this._timeline.stop(fr_);
    },
    toggle:function() {
      this._timeline.toggle();
    },
    repeat:{
      get:function()  {return this._timeline.repeat},
      set:function(b) {this._timeline.repeat = b}
    },
    enterframe:function(listener) {
      this.bind("enterframe",listener);
    },
    lastframe:function(listener) {
      this.bind("lastframe",listener);
    }
  });



