
  var uiEvents = [
    "click",
    "mouseover",
    "mouseout",
    "mousedown",
    "mouseup",
    "mousemove",
    "touchstart",
    "touchmove",
    "touchend",
    "touchcancel",
    "gesturestart",
    "gesturechange",
    "gestureend"
  ];
  var events = uiEvents.concat([
    "enterframe",
    "change",
    "lastframe",
    "complete",
    "progress",
    "resize"
  ]);

  // イベント登録 / 発行
  smart.Binder = smart.extend({
    init:function() {
      this.name = "Binder";
      this._listable = {};
      this._callbacks = {};

      this._enabled = true; // -- 120818
    },
    enabled:{
      get :function( ) {return this._enabled},
      set :function(b) {this._enabled = b}
    },
    bind:function(type, listener) {
      if(events.indexOf(type) == -1) {
        alert(SMART + ".bind" + PARAM_ERROR);
        return;
      }

      var listeners = this._listable[type];

      if (listeners == null) {
        this._listable[type] = [listener];
      }
      else if(listeners.indexOf(listener) == -1) {
        listeners.unshift(listener);
      }
      else {
        return; // -- 120902
      }

      // elementリスナー への登録 -- 調整 -- 120902
      if(uiEvents.indexOf(type) > -1 && this.element) {
        var instance = this;
        var fn = this._callbacks[type] = function(e) {
          var mouseObject = e; // イベント情報をそのまま設定 -- 120818
          mouseObject.targetElement = e.target;
          mouseObject.mouseX = e.layerX ? e.layerX : e.offsetX;
          mouseObject.mouseY = e.layerY ? e.layerY : e.offsetY;
          instance.trigger(e.type,mouseObject);

          // ネイティブイベントのコントロール
          // e.stopPropagation();
          // e.preventDefault();
        };
        this.element.addEventListener(type,fn);
      }
    },
    unbind:function(type, listener) {
      var listeners = this._listable[type];

      if (listeners != null) {
        var i = listeners.indexOf(listener);

        if (i != -1) { listeners.splice(i, 1); }

        if(listeners.length === 0) {
          listeners[type] = null;
          // elementリスナー から削除
          if(uiEvents.indexOf(type) > -1 && this.element) {
            this.element.removeEventListener(type,this._callbacks[type]);
            this._callbacks[type] = null;
          }
        }
      }
    },
    trigger:function(type,data) {
      // -- 120818 
      if(!this._enabled) { return; }
      if(!data) { data = {}; }
      data.target = this;
      data.type = type;
      var listeners = this._listable[type];
      if(!listeners) {
        for (var i = 0, len = listeners.length; i < len; i++) {
          if (listeners[i] != null) {
            listeners[i].call(this,data); // -- 120816
          }
        }
      }
    }
  });

