  // キャンバスオブジェクト <canvas>をラップ ----------------------------------------------
  smart.Canvas = smart.extend(smart.View,{
    // w,h 追加 -- 120531 
    init:function(w_, h_ ,img_) {
      smart.View.apply(this);
      this.name = "Canvas";

      // w,h,省略可に変更 -- 120911 
      if(typeof w_ == "object" && w_.nodeType == 1) {
        img_ = w_;
        w_ = img_.width;
        h_ = img_.height;
      }

      this._element = document.createElement("canvas"); //override
      this._element.style.position = "absolute";
      this._element.width  = this._width  = w_;
      this._element.height = this._height = h_;

      this._ctx = this._element.getContext("2d");

      this.id = SMART + "-canvas" + smart.guid++;
      this._transOrigin(); // -- 120531
      // 画像描画だけでなくなった場合、タイミングの調整が必要 -- 121013
      // ctx.save();
      // ctx.restore();
      if(smart.oldAndroid) {
        var rate = Math.sqrt(320 / w.screen.width);
        this._ctx.scale(rate,rate);
      }
      if(img_) { this.draw(img_) }
    },
    width: {
      get: function( ) {return this._width * this._scaleX},
      set: function(n) {this.scaleX = n / this._width} // エレメントに直接指定が必要？
    },
    height: {
      get: function( ) {return this._height * this._scaleY},
      set: function(n) {this.scaleY = n / this._height}
    },
    draw :function(img, sx, sy, sw, sh, dx, dy, dw, dh) {
      if(!sx) { sx = 0; }
      if(!sy) { sy = 0; }
      if(!sw) { sw = img.width; }
      if(!sh) { sh = img.height; }
      if(!dx) { dx = 0; }
      if(!dy) { dy = 0; }
      if(!dw) { dw = this._width; }
      if(!dh) { dh = this._height; }
      this._ctx.drawImage(img, sx, sy, sw, sh, dx, dy, dw, dh)
    },
    clear :function() {
      this._ctx.clearRect(0,0,this._width+1,this._height); // Android対策 1px大きく -- 120924
    },
    context :{
      get:function(){return this._ctx}
    }
  });


