  smart.Timeline = smart.extend(smart.Binder,{
    init:function(fps_) {
      smart.Binder.apply(this);
      this.name = "Timeline";
      this._fps      = fps_ || ( smart.timeline ? smart.timeline.fps : DEFAULT_FPS ); // -- 120829
      this._frame    = 0;
      this._total    = 0; // -- 120814
      this._timerID  = 0;
      this._repeat   = true; // -- 120814
    },
    fps:{
      get :function( ) {return this._fps},
      set:function(n){
        var active_ = this.active;
        this.stop();
        this._fps = n;
        if(active_) { this.play(); }
      }
    },
    frame:{
      get:function()  {return this._frame},
      set:function(n) {
        // -- 120819
        if(this._frame != n) {
          this.trigger("enterframe",{frame:(this._frame = n),total:this._total});
        }
      }
    },
    total:{
      get:function()  {return this._total},
      set:function(n) {this._total = n}
    },
    repeat:{
      get:function()  {return this._repeat},
      set:function(b) {this._repeat = b}
    },
    play:function(fr_) {
      if(fr_) { this._frame = fr_; }
      if(!this._timerID) {
        var instance = this;
        this._timerID = setInterval(function() {
          instance._frame++;
          instance.trigger("enterframe",{frame:instance._frame,total:instance._total});
          // -- 120814
          if(instance._total > 0 && instance._frame == instance._total) {
            instance.trigger("lastframe",{frame:instance._frame,total:instance._total}); // -- 120818
            if(instance._repeat) {
              instance._frame = 0;
            }
            else {
              instance.stop();
            }
          }
        },(1000 / this._fps));
      }
    },
    stop:function(fr_) {
      if(fr_) { this.frame = fr_; }
      if(this._timerID) {
        clearInterval(this._timerID);
        this._timerID = null;
      }
    },
    active:{
      get:function(){ return Boolean(this._timerID); }
    },
    toggle:function() {
      if(this.active) {
        this.stop();
      }
      else {
        this.play();
      }
    },
    enterframe:function(listener) {
      this.bind("enterframe",listener);
    },
    // -- 120818
    lastframe:function(listener) {
      this.bind("lastframe",listener);
    }
  });


