  // トゥイーン ---------------------------------------------------------
  smart.Tween = smart.extend(smart.Binder,{
    init:function() {
      smart.Binder.apply(this);
      this.name    = "Tween";
      this._list    = [];
      this._active  = false;
    },
    active:{
      get :function(){return this._active}
    },
    _toFrame:function(sec) {
      return Math.ceil(smart.timeline.fps * sec);
    },
    start :function(tar,params,ease,sec,delay,cb) {
      var tars = this._list;
      var newlist = [];
      if(!ease) { ease = "linear"; }
      if(!sec) { sec = 0.5; }
      if(!delay) { delay = 0; }
      if(typeof cb != "function") { cb = null; }
      for(var prop in params) {
        if (params.hasOwnProperty(prop)) {
          var stt = tar[prop];
          var end = params[prop];
          var totalfrm = this._toFrame(sec);
          var delayfrm = this._toFrame(delay);
          newlist.push(new TweenObject(tar,prop,stt,end,ease,totalfrm,delayfrm));
        }
      }
      if(cb) { newlist[newlist.length-1].cb = cb; } //コールバックは一回のみ
      for(var j = newlist.length;j--;) {
        var hit = 0;
        // ターゲット検索
        for(var i = tars.length;i--;) {
          if(newlist[j].tar == tars[i].tar && newlist[j].prop == tars[i].prop)  {
            if(tars[i].cb) { tars[i].cb(tars[i].tar); } // ** コールバック実行 -- 111108
            tars[i] = newlist[j];
            hit = 1;
            break;
          }
        }
        if(!hit) { tars.push(newlist[j]); }
      }
      if(!this._active) {
        this._active = true;
        var instance = this;
        smart.timeline.bind("enterframe",function(e) {
          console.log(e);
          var tars = instance._list;
          var obj;
          for(var i = tars.length;i--;) {
            obj = tars[i];
            if(obj.delay > 0) {
              obj.delay--;
            }
            else {
              obj.tar[obj.prop] = obj.ease(++obj.time ,obj.stt ,obj.diff ,obj.total);
            }

            // 終了処理
            if(obj.time >= obj.total) {
              if(obj.tar[obj.param] != obj.end) { obj.tar[obj.param] = obj.end; }
              tars.splice(i,1);
              if(obj.cb) { obj.cb(obj.tar); }
              obj.cb = null;
              obj.tar = null;
              obj.ease = null;
              obj = null;
            }
          }

          instance.trigger("change"); // -- 120818
          if(tars.length === 0) {
            smart.timeline.unbind("enterframe",arguments.callee);
            instance._active = false;
            instance.trigger("complete"); // -- 120818
          }
        });
      }
    },
    stop :function(tar,prop) {
      var tars = this._list;
      var obj;
      for(var i = tars.length;i--;) {
        obj = tars[i];
        if(!tar || obj.tar == tar) {
          if(!prop || obj.prop == prop) {
            tars.splice(i,1);
            // obj.finalize();
          }
        }
      }
    }
  });

  // 単純化 -- 120831 
  var TweenObject = function(tar_,prop_,stt_,end_,ease_,tfrm_,dfrm_) {
    this.tar    = tar_;
    this.prop   = prop_;
    this.stt    = stt_;
    this.diff   = end_ - stt_;
    this.end    = end_;
    this.ease   = easelist[ease_];
    this.time   = 0;
    this.total  = tfrm_;
    this.delay  = dfrm_;
    this.cb     = null;
    if(!this.ease) { alert(SMART + ".ease" + PARAM_ERROR); } // -- 120818
  }


  var easelist = {
    linear :function(t, b, c, d) {
      return c * t / d + b;
    },
    easeInSine :function(t, b, c, d) {
      return -c * Math.cos(t/d * (Math.PI/2)) + c + b;
    },
    easeOutSine :function(t, b, c, d) {
      return c * Math.sin(t/d * (Math.PI/2)) + b;
    },
    easeInOutSine :function(t, b, c, d) {
      return -c/2 * (Math.cos(Math.PI*t/d) - 1) + b;
    },
    easeInQuad :function(t, b, c, d) {
      return c*(t /= d)*t+b;
    },
    easeOutQuad :function(t, b, c, d) {
      return -c*(t /= d)*(t-2)+b;
    },
    easeInOutQuad :function(t, b, c, d) {
      if ((t /= d/2) < 1) { return c/2*t*t + b; }
      return -c/2 * ((--t)*(t-2) - 1) + b;
    },
    easeInCubic :function(t, b, c, d) {
      return c*(t /= d)*t*t + b;
    },
    easeOutCubic :function(t, b, c, d) {
      return c*((t=t/d-1)*t*t + 1) + b;
    },
    easeInOutCubic :function(t, b, c, d) {
      if ((t /= d/2) < 1) { return c/2*t*t*t + b; }
      return c/2*((t-=2)*t*t + 2) + b;
    },
    easeInQuart :function(t, b, c, d) {
      return c*(t /= d)*t*t*t+b;
    },
    easeOutQuart :function(t, b, c, d) {
      return -c*((t=t/d-1)*t*t*t-1)+b;
    },
    easeInOutQuart :function(t, b, c, d) {
      if ((t /= d/2) < 1) { return c/2*t*t*t*t + b; }
      return -c/2 * ((t-=2)*t*t*t - 2) + b;
    },
    easeInExpo :function(t, b, c, d) {
      return (t===0) ? b : c * Math.pow(2, 10 * (t/d - 1)) + b - c * 0.001;
    },
    easeOutExpo :function(t, b, c, d) {
      return (t==d) ? b+c : c * 1.001 * (-Math.pow(2, -10 * t/d) + 1) + b;
    },
    easeInOutExpo :function(t, b, c, d) {
      if (t===0) { return b; }
      if (t==d) { return b+c; }
      if ((t /= d/2) < 1) { return c/2 * Math.pow(2, 10 * (t - 1)) + b - c * 0.0005; }
      return c/2 * 1.0005 * (-Math.pow(2, -10 * --t) + 2) + b;
    },
    easeInBack :function  (t, b, c, d) {
      var s = 1.70158;
      return c * (t /= d) * t * ((s + 1) * t - s) + b;
    },
    easeOutBack :function(t, b, c, d) {
      var s = 1.70158;
      return c * ((t = t / d - 1) * t * ((s + 1) * t + s) + 1) + b;
    },
    easeInOutBack :function  (t, b, c, d) {
      var s = 1.70158;
      if ((t /= d / 2) < 1) { return c / 2 * (t * t * (((s *= (1.525)) + 1) * t - s)) + b; }
      return c / 2 * ((t -= 2) * t * (((s *= (1.525)) + 1) * t + s) + 2) + b;
    },
    easeOutBounce :function(t, b, c, d) {
      if ((t /= d) < (1 / 2.75)) {
        return c * (7.5625 * t * t) + b;
      }
      else if (t < (2 / 2.75)) {
        return c * (7.5625 * (t -= (1.5 / 2.75)) * t + 0.75) + b;
      }
      else if (t < (2.5 / 2.75)) {
        return c * (7.5625 * (t -= (2.25 / 2.75)) * t + 0.9375) + b;
      }
      else {
        return c * (7.5625 * (t -= (2.625 / 2.75)) * t + 0.984375) + b;
      }
    },
    easeOutElastic :function(t, b, c, d) {
      var p = 1.08;
      if (t===0) { return b; }
      if ((t /= d)==1) { return b+c; }
      if (!p) { p=d*0.3; }
      var s,a;
      if (!a || a < Math.abs(c)) {
        a=c;
        s=p/4;
      }
      else {
        s = p/(2*Math.PI) * Math.asin (c/a);
      }
      return (a*Math.pow(2.5,-10*t) * Math.sin( (t*d-s)*(2*Math.PI)/p ) + c + b);
    }
  };


