  // 表示オブジェクトの基
  smart.View = smart.extend(smart.Binder,{

    init:function() {
      smart.Binder.apply(this);
      this.name     = "View";
      this._id       = "";

      this._parent   = null;
      this._element  = document.createElement("div");
      this._visible  = true;
      this._x        = 0;
      this._y        = 0;
      this._alpha    = 1;
      this._rotation = 0;
      this._regX     = 0; // -- 120531
      this._regY     = 0;
      this._scaleX   = 1; // -- 120115
      this._scaleY   = 1;
      this._cursor   = "auto"; // -- 120819
      this._z        = 0;    // -- 120902
      this._bg       = null; // -- Box,Textから移動 -- 120821
      this._border   = null;
    },
    element:{
      get:function(){return this._element}
    },
    id: {
      get: function( ) {return this._id},
      set: function(s) {
        this._id = s;
        if(this._element) { this._element.id = s; }
      }
    },
    bg: {
      get: function() {
        if(!this._bg) { this._bg = new smart.Background(this._element); }
        return this._bg;
      }
    },
    border: {
      get: function() {
        if(!this._border) { this._border = new smart.Border(this._element); }
        return this._border;
      }
    },
    parent:{
      get :function( ) {return this._parent}
    },
    visible:{
      get :function( ) {return this._visible},
      set :function(b) {this._element.style.display = (this._visible = b) ? "block" : "none"}
    },
    x: {
      get: function( ) {return this._x},
      set: function(n) {
        this._x = n;
        this._transform();
      }
    },
    y: {
      get: function( ) {return this._y},
      set: function(n) {
        this._y = n;
        this._transform();
      }
    },
    z:{ // -- 120902
      get :function( ) {return this._z},
      set :function(n) {
        this._element.style.zIndex = (this._z = n);
      }
    },
    alpha:{
      get :function( ) {return this._alpha},
      set :function(n) {this._element.style.opacity = this._alpha = n}
    },
    scale : {
      get :function( ) {return this._scaleX}, // x 優先
      set :function(n) {
        this._scaleX = this._scaleY = n;
        this._transform();
      }
    },
    scaleX : {
      get :function( ) {return this._scaleX},
      set :function(n) {
        this._scaleX = n;
        this._transform();
      }
    },
    scaleY : {
      get :function( ) {return this._scaleY},
      set :function(n) {
        this._scaleY = n;
        this._transform();
      }
    },
    regX: {
      get: function( ) {return this._regX},
      set: function(n) {
        this._regX = n;
        this._transOrigin();
      }
    },
    regY: {
      get: function( ) {return this._regY},
      set: function(n) {
        this._regY = n;
        this._transOrigin();
      }
    },
    rotation:{
      get :function( ) {return this._rotation},
      set :function(n) {
        this._rotation = n;
        this._transform();
      }
    },
    matrix:{ // -- 120908
      set :function(arr) {
        this._element.style[PREFIX + "Transform"] = "matrix(" + arr.join(",") + ")";
      }
    },
    _transOrigin:function() {
      this._element.style[PREFIX + "TransformOrigin"] = this._regX + "px " + this._regY + "px";
    },
    _transform:function() {
      this._element.style[PREFIX + "Transform"] = "translate(" + this._x + "px," + this._y + "px) " + "rotate(" + this._rotation + "deg)" + "scale(" + this._scaleX + "," + this._scaleY + ")";
    },
    stage :{
      get :function() {
        var instance = this;
        while(!instance.isStage) {
          if(instance.parent) { instance = instance.parent; }
          else { return null; }
        }
        return instance;
      }
    },
    cursor:{ // -- 120819
      get :function( ) {return this._cursor},
      set :function(s) {
        if(!s) { s = "auto"; }
        this._element.style.cursor = (this._cursor = s);
      }
    },
    click:function(fn) {
      this.bind("click",fn);
    },
    mouseover:function(fn) {
      this.bind("mouseover",fn);
    },
    mouseout:function(fn) {
      this.bind("mouseout",fn);
    },
    mousedown:function(fn) {
      this.bind("mousedown",fn);
    },
    mouseup:function(fn) {
      this.bind("mouseup",fn);
    },
    mousemove:function(fn) {
      this.bind("mousemove",fn);
    },
    // -- 121012
    touchstart:function(fn) {
      this.bind("touchstart",fn);
    },
    touchmove:function(fn) {
      this.bind("touchmove",fn);
    },
    touchend:function(fn) {
      this.bind("touchend",fn);
    }
  });


